Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Friends | List of all members
Botan::Fanout_Filter Class Referenceabstract

`#include <filter.h>`

Inheritance diagram for Botan::Fanout_Filter:

## Public Member Functions
virtual bool | attachable ()
virtual void | end_msg ()
virtual std::string | name () const =0
virtual void | start_msg ()
virtual void | write (const uint8_t input[], size_t length)=0

## Protected Member Functions
void | attach (Filter *f)
void | incr_owns ()
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)
void | set_next (Filter *f[], size_t n)
void | set_port (size_t n)

## Friends
class | Threaded_Fork

## Detailed Description

This is the abstract Fanout_Filter base class.

Definition at line 152 of file filter.h.

## Member Function Documentation

void Botan::Fanout_Filter::attach | ( | Filter * | f | ) |
| inline protected

Definition at line 164 of file filter.h.

Referenced by Botan::Chain::Chain().

164 { Filter::attach(f); }

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

virtual void Botan::Filter::end_msg | ( |  | ) |
| inline virtual inherited

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::Base64_Decoder, Botan::Hex_Decoder, Botan::Base64_Encoder, and Botan::Hex_Encoder.

Definition at line 46 of file filter.h.

46 {}

void Botan::Fanout_Filter::incr_owns | ( |  | ) |
| inline protected

Increment the number of filters past us that we own

Definition at line 158 of file filter.h.

Referenced by Botan::Chain::Chain().

158 { ++m_filter_owns; }

virtual std::string Botan::Filter::name | ( |  | ) | const
| pure virtual inherited

Returns
  descriptive name for this filter

Implemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::Fork, Botan::Hex_Decoder, Botan::Base64_Decoder, Botan::DataSink_Stream, Botan::Chain, Botan::StreamCipher_Filter, Botan::Cipher_Mode_Filter, Botan::BitBucket, Botan::Hex_Encoder, Botan::SecureQueue, and Botan::Base64_Encoder.

Referenced by Botan::Keyed_Filter::set_iv().

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Fanout_Filter::set_next | ( | Filter * | f[],
|  | size_t | n
| ) |  |
| inline protected

Definition at line 162 of file filter.h.

Referenced by Botan::Fork::Fork(), and Botan::SecureQueue::SecureQueue().

162 { Filter::set_next(f, n); }

void Botan::Fanout_Filter::set_port | ( | size_t | n | ) |
| inline protected

Definition at line 160 of file filter.h.

Referenced by Botan::Fork::set_port().

160 { Filter::set_port(n); }

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

virtual void Botan::Filter::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| pure virtual inherited

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::Base64_Decoder, Botan::Fork, Botan::Hex_Decoder, Botan::DataSink_Stream, Botan::StreamCipher_Filter, Botan::Chain, Botan::Hex_Encoder, Botan::Base64_Encoder, Botan::BitBucket, and Botan::SecureQueue.

Referenced by Botan::Filter::send(), and Botan::Pipe::write().

## Friends And Related Function Documentation

friend class Threaded_Fork
| friend

Definition at line 167 of file filter.h.

The documentation for this class was generated from the following file:

- src/lib/filters/filter.h